package Echiquier.Modele.Piece;

import Echiquier.Modele.Case;
import Echiquier.Modele.ColorJoueur;

public class Dame extends Piece {
    public Dame(ColorJoueur colorJoueur) {
        super(colorJoueur);
    }

    public boolean estDpValide(Case depart, Case arrive) {

        if(estMemeJouer(arrive)){
            return false;
        }

        //Si le deplace n'est pas en ligne ou en diagonale return false
        if(!echiquier.estEnLigne(arrive,depart) && !echiquier.estEnDiagonales(depart,arrive) )
            return false;

        //traiter le deplacement bloque
        if(echiquier.estEnDiagonales(depart,arrive) && echiquier.estBloqueDiagonales(depart, arrive) ||
                echiquier.estEnLigne(depart,arrive) && echiquier.estBloqueLigne(depart, arrive)){
            return false;
        }
        return true;
    }
}
