package Echiquier.Modele;

import Echiquier.Echiquier;
import Echiquier.Modele.Piece.Piece;

public class Case{
    //le numéro de ligne
    private int lig;
    //le numéro de colonne
    private int col;
    //le piece dans le case
    private Piece piece;

    public Case(int lig, int col) throws Exception {
        if(lig < 0 || col < 0 || lig >= Echiquier.MAXLIG || col >= Echiquier.MAXCOL)
            throw new Exception("Le ligne faut entre 1 à " + (Echiquier.MAXLIG - 1) + ", La colonne faut entre 1 à " + (Echiquier.MAXCOL - 1));
        this.lig = lig;
        this.col = col;
    }

    public boolean estEuPiece(){
        if(null == piece)
            return false;
        return true;
    }

    public Piece getPiece() {
        return piece;
    }

    public void setPiece(Piece piece) {
        this.piece = piece;
    }

    public int getCol() {
        return col;
    }

    public int getLig() {
        return lig;
    }

    public String toString(){
        return "(" + (Echiquier.MAXLIG - lig) + "," + (char)('A'+ col) + ")";
    }

    public boolean estMeme(Case unCase){
        return this.col == unCase.col && this.lig == unCase.col;
    }

}
