package Echiquier.Modele;

import org.junit.Assert;
import org.junit.Test;

public class CaseTest {
    @Test
    public void testConstructeurLegal() throws Exception{
        int lig = 3;
        int col = 4;
        Case unCase = new Case(lig,col);
    }

    @Test(expected=Exception.class)
    public void testConstructeurIllegal1() throws Exception{
        int lig = 8;
        int col = 1;
        Case unCase = new Case(lig,col);
    }

    @Test(expected=Exception.class)
    public void testConstructeurIllegal2() throws Exception{
        int lig = -Integer.MAX_VALUE;
        int col = 6;
        Case unCase = new Case(lig,col);
    }

    @Test(expected=Exception.class)
    public void testConstructeurIllegal3() throws Exception{
        int lig = 7;
        int col = -Integer.MAX_VALUE;
        Case unCase = new Case(lig,col);
    }

    @Test(expected=Exception.class)
    public void testConstructeurIllegal4() throws Exception{
        int lig = 5;
        int col = 8;
        Case unCase = new Case(lig,col);
    }

    @Test
    public void testToString() throws Exception{
        Case unCase = new Case(2,3);
        String resAttendu = "(6,D)";
        String resEffectif = unCase.toString();
        Assert.assertEquals("Case toString", resAttendu,resEffectif);
    }
}
